; BOOT_IT.ASM - performs a warm reboot of the computer
; NOTE: close all files before calling this procedure
; Protected Mode Version.
; Programmer:   Paul Bosselaers
; Date:         7/18/95

.model large

.data
; real mode register data structure
rm_EDI  DD      0
rm_ESI  DD      0
rm_EBP  DD      0
rm_Res  DD      0
rm_EBX  DD      0
rm_EDX  DD      0
rm_ECX  DD      0
rm_EAX  DD      0
rm_flg  DW      0
rm_ES   DW      0
rm_DS   DW      0
rm_FS   DW      0
rm_GS   DW      0
rm_IP   DW      0000h
rm_CS   DW      0FFFFh
rm_SP   DW      0
rm_SS   DW      0

PUBLIC BOOT_IT

.code
BOOT_IT proc    far
        mov     dx,0040h                ; BIOS area
        mov     ds,dx
        mov     bx,0072h
        xor     ax,ax
        mov     word ptr [bx],1234h     ; warm boot

        mov     ax,@data
        mov     es,ax
        mov     di,offset dgroup:rm_EDI
        mov     ax,0301h                ; call real mode procedure function
        xor     bx,bx
        xor     cx,cx
        int     31h                     ; call boot procedure

BOOT_IT endp
end


