; function CD.ASM to change drive and directory
; gets path from Clipper
; Returns Logical True (1) if successful, logical false (0) if not.
; Programmer: Paul Bosselaers
; Date:       9/21/94
; updated 10/20/97 to try to use Windows 95 (DOS 7.0) long filename first
; Note: Windows 95 stuff does not work in protected mode as written
; seems to work ok in real mode though

.model large
.286

include \clipper5\include\extasm.inc            ; extend definitions

PUBLIC CD

.code
CD      proc    far
; save registers as required
        push    bp
        mov     bp,sp
	push	ds
	push	es
        push    si
        push    di
        push    dx
        push    cx
        push    bx

; check if any parameter was passed, ax = 0 means nothing passed
        xor     ax,ax
        push    ax
        call    __parinfo
        add     sp,2
        or      ax,ax
        jz      error

; see if a directory was entered
; get length of file spec. from clipper, ax has length
        mov     ax,1
        push    ax
        call    __parclen
        add     sp,2
        xor     bx,bx        
        cmp     ax,3                    ; less than 3 = just drive passed
        jae     get_spec
        mov     bx,1                    ; bx=1 means only drive

; get file spec. from clipper, dx has segment, ax has offset
get_spec:
        push    bx
        mov     ax,1
        push    ax
        call    __parc
        add     sp,2
        pop     bx
        push    ds                              ; save current segment
        mov     ds,dx                           ; point to path
	mov 	si,ax

; check for drive separator
get_drv:
	cmp     byte ptr [si+1],':'
        jnz     chg_dir                         ; not found just change dir.

; change drive
	mov 	dx,[si]
        and     dl,0dfh                 ; change drive letter to upper case
        sub     dl,'A'                  ; change drive letter to drive no.
        mov     ah,0Eh                  ; select-disk function
        int     21h                     ; change drive

; check if we are on the disk we moved to
        mov     ah,19h                  ; get-disk function
        int     21h
        cmp     al,dl                   ; if the two are the same we're ok
        jne     error

        or      bx,bx                   ; see if drive only
        jnz     good_exit               ; yes, goodbye

; change the directory
chg_dir:
	mov 	dx,si                   ; dx now has offset of path
        stc                             ; set carry flag for versions < 7.0
        mov     ax,7139h                ; make directory with long filename
        int     21h
        jnc     good_exit               ; ok
        cmp     ax,7100h                ; if ax=7100h try old dos function
        jne     error                   ; otherwise abort

old_dos:
        mov     ah,3Bh                  ; set-directory function
        int     21h                     ; change directory
        jc      error

good_exit:
; set code for good exit
        mov     ax,0001
        jmp     short send_code

; set code for error
error:
        xor     ax,ax                           ; ax = 0

; return error code to clipper
send_code:
        pop     ds
        push    ax
        call    __retl
        add     sp,2

;restore registers
        pop     bx
        pop     cx
        pop     dx
        pop     di
        pop     si
        pop     es
        pop     ds
        pop     bp
        ret
CD      endp
end

        
