; function FlopSize to return size of floppy drive passed from Clipper
; needs parameter #2 passed by reference to hold floppy size as follows:
; 1=360K, 2=1.2M, 3=720K, 4=1.44M
; function returns 0 if no error, 2, error encounterd,
; 3 = invalid drive passed
; Programmer:   Paul Bosselaers
; Date:         8/4/94

.model large
.286

include \clipper5\include\extasm.inc

PUBLIC FlopSize

.code
FlopSize        proc    far
; save registers
        push    bp
        mov     bp,sp
        push    ds
        push    es
        push    di
        push    si
        push    dx
        push    cx
        push    bx

; get drive number from Clipper (A=0, B=1)
        mov     ax,1
        push    ax
        call    __parni                         ; returns number in ax
        add     sp,2

; check for valid number, 0 or 1
        or      al,al                           ; is it 0?
        je      check_drive                     ; yes, go for it
        cmp     al,1                            ; is it 1?
        je      check_drive                     ; yes, go for it

; invalid number so exit        
        mov     ax,0003h
        jmp     short send_code

; check drive parameters
check_drive:
        mov     dx,ax                           ; drive number in dl
        mov     ah,08h                          ; return drive parameters
        int     13h
        jc      send_err
        xor     bh,bh

; return floppy drive size        
        mov     ax,0002                         ; param. #2
        push    ax
        push    bx
        call    __storni
        add     sp,4

        xor     ax,ax                           ; setup for good exit
        jmp     short send_code

; check for error type
send_err:
        mov     ax,0002h                        ; code for other error

send_code:
; send exit code to Clipper
        push    ax
        call    __retni
        add     sp,2

; restore registers
        pop     bx
        pop     cx
        pop     dx
        pop     si
        pop     di
        pop     es
        pop     ds
        pop     bp
        ret

FlopSize        endp
end
