; program GETBOOT.ASM to get boot drive.
; NOTE: Only works for DOS V4.0 and up
; entry conditions: none
; exit conditions : returns drive letter if DOS ok, otherwise returns ?
; no other procedures used
; Programmer:   Paul Bosselaers
; Date:         9/12/94

.model large                                    ; Clipper needs large model
.286

include \clipper5\include\extasm.inc            ; extend definitions

PUBLIC GETBOOT

.data

boot_drive db   ?

.code

GETBOOT proc    far
; save registers as required
        push    bp
        mov     bp,sp
        push    ds
        push    es
        push    si
        push    di
        push    dx
        push    cx
        push    bx

; initialize data segment
        mov     ax,@data
        mov     ds,ax

; call DOS
        mov     ah,30h                          ; get DOS version function
        xor     al,al                           ; zero out al
        int     21h                             ; get version in ax

; DOS returns the major version in AL, the minor version in AH
        cmp     al,4                            ; version 4?
        jb      bad_dos                         ; less than 4 is N.G.

; find boot drive code
        mov     ax,3305h
        int     21h                             ; DL has boot code (A=1,etc)
        add     dl,40h                          ; convert to char ('A' = 41h)
        mov     boot_drive,dl
        jmp     short send_code

bad_dos:
        mov     boot_drive,'?'

; return error code to clipper
send_code:
        mov     ax,1                            ; length of return string
        push    ax
        mov     dx, seg boot_drive
        mov     ax,offset boot_drive
        push    dx
        push    ax
        call    __retclen
        add     sp,6

;restore registers
        pop     bx
        pop     cx
        pop     dx
        pop     di
        pop     si
        pop     es
        pop     ds
        pop     bp
        ret
GETBOOT endp
end

