; function GETDIR.ASM to get directory for a specified drive.
; gets drive letter from Clipper, defaults to current drive.
; returns current directory of drive specified.
; on error returns empty string.
; Programmer: Paul Bosselaers
; Date:       9/21/94

.model large
.286

include \clipper5\include\extasm.inc            ; extend definitions

PUBLIC GETDIR

.data
directory       db      '\'          ; get dir func. doesn't get leading '\'
curr_dir        db      65 dup(0)               ; holding area for path

.code
GETDIR  proc    far
; save registers as required
        push    bp
        mov     bp,sp
        push    ds
        push    si
        push    di
        push    dx

; check if any parameter was passed
        xor     ax,ax
        push    ax
        call    __parinfo
        add     sp,2
        or      ax,ax
        jnz     get_spec                ; get drive letter from Clipper

; setup to check default drive
        mov     ax,@data                ; look at data segment
        mov     ds,ax
        mov     si,offset curr_dir      ; point to buffer for path
        xor     dx,dx                   ; no param, so look at default drive
        jmp     short get_dir

; get file spec. from clipper, dx has segment, ax has offset
get_spec:
        mov     ax,1
        push    ax
        call    __parc
        add     sp,2

        mov     ds,dx                   ; get letter
        mov     si,ax
        mov     dl,[si]                 ; move char into dl

        mov     ax,@data                ; look at data segment
        mov     ds,ax
        mov     si,offset curr_dir      ; point to buffer for path

; check if valid char entered for drive
; good char is between A and Z or between a and z
        cmp     dl,'A'
        jb      error
        cmp     dl,'Z'
        jbe     make_num
        cmp     dl,'a'
        jb      error
        cmp     dl,'z'
        ja      error
        sub     dl,020h                 ; change drive letter to upper case

make_num:
        sub     dl,040h                 ; change drive letter to drive no.

get_dir:
        mov     ax,4700h
        int     21h                     ; get dir.
        jnc     good_exit

error:
        mov     ax,offset curr_dir
        jmp     short send_code

good_exit:
        mov     ax,offset directory

send_code:
        push    ds
        push    ax
        call    __retc
        add     sp,4

;restore registers
        pop     dx
        pop     di
        pop     si
        pop     ds
        pop     bp
        ret
GETDIR  endp
end

        

