; function GETFATTR.ASM to get file attributes 
; gets file spec. from Clipper, attribute must be passed by reference
; spec is param. 1, attribute is param 2
; returns attribute as follows:
;       Normal          0
;       Read Only       1
;       Hidden          2
;       System          4
;       Archive        32
; attributes can be combined, eg. Hidden and Read-Only = 3
; Returns Logical True (1) if successful, logical false (0) if not.
; Note: if function returns false, value of file attribute is meaningless.
; Programmer: Paul Bosselaers
; Date:       9/22/94

.model large
.286

include \clipper5\include\extasm.inc            ; extend definitions

PUBLIC GETFATTR

.code
GETFATTR      proc    far
; save registers as required
        push    bp
        mov     bp,sp
        push    ds
        push    si
        push    di
        push    dx
        push    cx

; check if 2 parameters were passed, exit with error if not.
        xor     ax,ax
        push    ax
        call    __parinfo
        add     sp,2
        cmp     ax,2
        jne     error

; get file spec. from clipper, dx has segment, ax has offset
        mov     ax,1
        push    ax
        call    __parc
        add     sp,2
        push    ds                      ; save current segment
        mov     ds,dx                   ; ds now has filespec segment
        mov     dx,ax                   ; dx now has filespec offset

; now do it
        mov     ah,43h                  ; get/set file attribute function
        mov     al,00h                  ; get em
        int     21h
        jc      error

; set param. 2 to file attribute
        pop     ds
        mov     ax,0002                 ; param. # 2
        push    ax
        push    cx                      ; attribute
        call    __storni
        add     sp,4

good_exit:
; set code for good exit
        mov     ax,0001
        jmp     short send_code

; set code for error
error:
        pop     ds
        xor     ax,ax                           ; ax = 0

; return error code to clipper
send_code:
        push    ax
        call    __retl
        add     sp,2

;restore registers
        pop     cx
        pop     dx
        pop     di
        pop     si
        pop     ds
        pop     bp
        ret
GETFATTR      endp
end

        

