; function ISDIR.ASM to check if directory exists
; gets path from Clipper (can include drive spec.)
; for floppy drives will return false if drive is not ready, even if
; directory exists.
; Returns Logical True (1) if successful, logical false (0) if not.
; Programmer: Paul Bosselaers
; Date:       9/21/94

.model large
.286

include \clipper5\include\extasm.inc            ; extend definitions

PUBLIC ISDIR

.data
directory       db      '\'          ; get dir func. doesn't get leading '\'
curr_dir        db      65 dup(0)               ; holding area for path

.code
ISDIR      proc    far
; save registers as required
        push    bp
        mov     bp,sp
        push    ds
        push    si
        push    di
        push    dx

; check if any parameter was passed
        xor     ax,ax
        push    ax
        call    __parinfo
        add     sp,2
        or      ax,ax
        jz      error

; get default dir
        push    ds
        mov     ax,@data                ; look at data segment
        mov     ds,ax
        mov     si,offset curr_dir      ; point to buffer for path
        xor     dx,dx                   ; no param, so look at default drive

get_dir:
        mov     ax,4700h
        int     21h                     ; get dir.
        jc      error
        pop     ds

; get file spec. from clipper, dx has segment, ax has offset
        mov     ax,1
        push    ax
        call    __parc
        add     sp,2
        push    ds
        mov     ds,dx
        mov     dx,ax

        mov     ah,3Bh                  ; set-directory function
        int     21h                     ; change directory
        jc      error

; dir. exists so change back to old dir.
        mov     ax,@data                ; look at data segment
        mov     ds,ax
        mov     dx,offset directory
        mov     ah,3Bh                  ; set-directory function
        int     21h                     ; change directory
        jc      error

good_exit:
; set code for good exit
        mov     ax,0001
        jmp     short send_code

; set code for error
error:
        xor     ax,ax                           ; ax = 0

; return error code to clipper
send_code:
        pop     ds
        push    ax
        call    __retl
        add     sp,2

;restore registers
        pop     dx
        pop     di
        pop     si
        pop     ds
        pop     bp
        ret
ISDIR      endp
end

        

