; function ISDRIVE.ASM to check if drive exists
; gets drive letter from Clipper
; for floppy drives will return false if drive is not ready, even if
; it exists.
; returns logical true (1) if successful, logical false if not.
; Programmer: Paul Bosselaers
; Date:       9/21/94
;

.model large
.286

include \clipper5\include\extasm.inc            ; extend definitions

PUBLIC ISDRIVE

.code
ISDRIVE  proc    far
; save registers as required
        push    bp
        mov     bp,sp
        push    ds
        push    si
        push    di
        push    dx

; check if any parameter was passed
        xor     ax,ax
        push    ax
        call    __parinfo
        add     sp,2
        or      ax,ax
        jz      good_exit               ; default drive does exist

; get file spec. from clipper, dx has segment, ax has offset
        mov     ax,1
        push    ax
        call    __parc
        add     sp,2
        push    ds
        mov     ds,dx
        mov     si,ax
        mov     dl,[si]                 ; move char into dl
; check if valid char entered for drive
; good char is between A and Z or between a and z
        cmp     dl,'A'
        jb      error
        cmp     dl,'Z'
        jbe     check_drive
        cmp     dl,'a'
        jb      error
        cmp     dl,'z'
        ja      error
        sub     dl,020h                 ; change drive letter to upper case

check_drive:
        sub     dl,'A'                  ; change drive letter to drive no.
        push    dx                      ; save it        
        inc     dl                      ; this function is 1 based (A=1)
        mov     ah,36h                  ; get-free-disk-space function
        int     21h                     ; returns FFFFh in ax if drive N.G.
        pop     dx                      ; get drive number back
        cmp     ax,0FFFFh
        je      error

good_exit:
; set code for good exit
        mov     ax,0001
        jmp     short send_code

; set code for error
error:
        xor     ax,ax                           ; ax = 0

; return error code to clipper
send_code:
        pop     ds
        push    ax
        call    __retl
        add     sp,2

;restore registers
        pop     dx
        pop     di
        pop     si
        pop     ds
        pop     bp
        ret
ISDRIVE  endp
end

        

