; function ISEXTKBD to check if an extended keyboard is being used
; Returns Logical True if yes, Logical False if no
; Programmer: Paul Bosselaers
; Date:       2/10/95

.model large
.286

include \clipper5\include\extasm.inc            ; extend definitions

PUBLIC ISEXTKBD

.code
ISEXTKBD      proc    far
; save registers as required
        push    bp
        mov     bp,sp
        push    ds
        push    si
        push    di
        push    bx

; check the hardware for extended keyboard status
        push    ds                      ; save ds
        mov     bx,40h                  ; point DS to the BIOS data area
        mov     ds,bx                   ; 
        mov     bx,96h                  ; point to ext .keyboard status flag
        test    byte ptr [bx], 010h     ; is it on?

        pop     ds                      ; restore ds
        jz      no_ext                  ; old keyboard
        mov     ax,0001h                ; 1 = TRUE
        jmp     short send_code

no_ext:
        xor     ax,ax                   ; 0 = FALSE
        
send_code:
        push    ax
        call    __retl                  ; return code to Clipper
        add     sp,2

;restore registers
        pop     bx
        pop     di
        pop     si
        pop     ds
        pop     bp
        ret
ISEXTKBD      endp
end


