; function ISPRINTR.ASM to check if a printer is ready.
; Entry Conditions: gets port # from Clipper
; 0 = LPT1, 1 = LPT2, 2 = LPT3, default is LPT1
; returns logical true (1) if ready, logical false if not.
; Programmer: Paul Bosselaers
; Date:       2/9/95

.model large
.286

include \clipper5\include\extasm.inc            ; extend definitions


PUBLIC ISPRINTR

.code
ISPRINTR  proc    far
; save registers as required
        push    bp
        mov     bp,sp
        push    ds
        push    si
        push    di
        push    dx

; check if any parameter was passed
        xor     ax,ax
        push    ax
        call    __parinfo
        add     sp,2
        or      ax,ax
        jz      check_it

; get port number from Clipper
        mov     ax,1
        push    ax
        call    __parni
        add     sp,2

; check port number, 0-2 are valid
        cmp     ax,2
        ja      error

check_it:
        mov     dx,ax                           ; need port # in dx
        mov     ah,02h                          ; check status function
        int     17h                             ; status is in ah
        cmp     ah,90h                          ; is printer ready?
        jne     error                           ; no.

good_exit:
; set code for good exit
        mov     ax,0001
        jmp     short send_code

error:
; set code for error
        xor     ax,ax

send_code:
; return code to clipper
        push    ax
        call    __retl
        add     sp,2

;restore registers
        pop     dx
        pop     di
        pop     si
        pop     ds
        pop     bp
        ret
ISPRINTR  endp
end

        

