; IsShare.asm - a Clipper callable function to determine if DOS SHARE
; program is installed. Returns logical true (1) if installed, returns
; false (0) if not installed.
; Programmer:   Paul Bosselaers
; Date:         8/2/94

.model large                                    ; Clipper needs large model
.286

include \clipper5\include\extasm.inc            ; Clipper extend functions

PUBLIC IsShare

.code
IsShare         Proc    far
; save registers
        push    bp
        mov     bp,sp
        push    ds
        push    es
        push    di
        push    si

; FFh returned in al means share installed
        mov     ah,10h
        xor     al,al
        int     2Fh                             
        cmp     al,0FFh
        je      set_true

; set ax to zero for false
        xor     ax,ax
        jmp     short send_code

; set ax to 1 for true
set_true:
        mov     ax,0001

; send return code to Clipper
send_code:
        push    ax
        call    __retl
        add     sp,2

; restore registers
        pop     si
        pop     di
        pop     es
        pop     ds
        pop     bp
        ret
IsShare endp
end


