; Clipper procedure IsDisk to check if a drive exists, returns logical true
; gets 1-based drive number from Clipper
; (1) if yes, false (0) if no
; Programmer: Paul Bosselaers
; Date:       8/3/94

.model large
.286

include \clipper5\include\extasm.inc            ; Clipper extend definitions

PUBLIC IsDisk

.code
IsDisk  proc    far
; save registers
        push    bp
        mov     bp,sp
        push    ds
        push    es
        push    di
        push    si

; get drive number from Clipper (A=1, B=2, etc)
        mov     ax,1
        push    ax
        call    __parni                         ; returns number in ax
        add     sp,2

check_drive:
        mov     dx,ax                   ; need drive number in dl
        mov     ah,36h                  ; get-free-disk-space function
        int     21h                     ; returns FFFFh in ax if drive N.G.
        cmp     ax,0FFFFh
        je      bad_drive

; setup for good exit
        mov     ax,0001
        jmp     short send_code

bad_drive:
        xor     ax,ax

send_code:
; send error code back to Clipper
        push    ax
        call    __retl
        add     sp,2

; restore registers
        pop     si
        pop     di
        pop     es
        pop     ds
        pop     bp
        ret

IsDisk  endp

        end
        
           
