; function KBD_ON to enable keyboard after disabling with proc KBD_OFF
; Entry conditions: none
; Returns: NIL
; Programmer: Paul Bosselaers (I borrowed some stuff from David J. Crone)
; Date:       5/04/95

.model large
.286

include \clipper5\include\extasm.inc            ; extend definitions
include \masm61\include\kbstuff.inc             ; keyboard definitions

_wait_pckb_send    MACRO        ; Wait until PC's 8042 ready for new data
        LOCAL wpkbs_10

        sub     cx,cx           ; max. wait time
wpkbs_10:
        mov     dx,pc_k_status  ; port 64h
        in      al,dx           ; wait for input buffer empty
        and     ax,KS_IBF       ; ibf=0 means buffer empty
        loopnz  wpkbs_10

        ENDM

PUBLIC KBD_ON

.code
KBD_ON      proc    far
; save registers as required
        push    bp
        mov     bp,sp
        push    ds
        push    si
        push    di
        push    dx
        push    cx
        push    ax

; send command directly to the keyboard command port (64h)

        cli                                     ; disable interrupts

        _wait_pckb_send                         ; wait till O.K. to send

        mov     al,KC_ENABLE                    ; enable-keyboard command

        mov     dx,pc_k_control                 ; port 64h
        out     dx,al                           ; output command

        sti                                     ; enable interrupts

; return NIL to Clipper
        call    __ret

;restore registers
        pop     ax
        pop     cx
        pop     dx
        pop     di
        pop     si
        pop     ds
        pop     bp
        ret
KBD_ON      endp

end



