# make file for creating lowlib.lib for nmake

# tool definitions
CC  = cl
ASM = ml
LIBR = lib

COPT = /c /nologo /AL /FPa /Gs /Oalt /Zl /G2
AOPT = /c /nologo
LOPT = /NOLOGO

# rules
.c.obj:
        $(CC) $(COPT) $<

.asm.obj:
        $(ASM) $(AOPT) $<

# can only use clipbrd or clipbrdp in lib, default to prot. mode version
CLIPB = clipbrdp

# build the lib
lowlib.lib:     CDROM.OBJ CHGRATTR.OBJ $(CLIPB).OBJ \
                CLKSPINR.OBJ ISWIN.OBJ FULLPATH.OBJ \
                NO_BOOT.OBJ PRSCROFF.OBJ PRSCRON.OBJ BOOT_IT.OBJ \
                CAPS_OFF.OBJ CAPS_ON.OBJ CD.OBJ CUR_DRV.OBJ \
                FCOMMIT.OBJ FLOPSIZE.OBJ GETBOOT.OBJ GETDIR.OBJ \
                GETDRIVE.OBJ GETFATTR.OBJ IS_DISK.OBJ ISDIR.OBJ \
                ISDRIVE.OBJ ISEXTKBD.OBJ ISFLOPPY.OBJ ISPRINTR.OBJ \
                ISSHARE.OBJ KBD_OFF.OBJ KBD_ON.OBJ KBDSTAT.OBJ \
                MD.OBJ NUM_OFF.OBJ NUM_ON.OBJ PRSCREEN.OBJ RD.OBJ \
                SETBORDR.OBJ SETDRIVE.OBJ SETFATTR.OBJ
    del lowlib.lib
    $(LIBR) lowlib $(LOPT) +CDROM.OBJ +CHGRATTR.OBJ +$(CLIPB).OBJ;
    $(LIBR) lowlib $(LOPT) +CLKSPINR.OBJ +ISWIN.OBJ +FULLPATH.OBJ;
    $(LIBR) lowlib $(LOPT) +NO_BOOT.OBJ +PRSCROFF.OBJ +PRSCRON.OBJ;
    $(LIBR) lowlib $(LOPT) +BOOT_IT.OBJ +CAPS_OFF.OBJ +CAPS_ON.OBJ;
    $(LIBR) lowlib $(LOPT) +CUR_DRV.OBJ +FCOMMIT.OBJ +FLOPSIZE.OBJ;
    $(LIBR) lowlib $(LOPT) +GETBOOT.OBJ +GETDIR.OBJ +ISDIR.OBJ +CD.OBJ;
    $(LIBR) lowlib $(LOPT) +GETDRIVE.OBJ +GETFATTR.OBJ +IS_DISK.OBJ;
    $(LIBR) lowlib $(LOPT) +ISDRIVE.OBJ +ISSHARE.OBJ +NUM_OFF.OBJ;
    $(LIBR) lowlib $(LOPT) +ISEXTKBD.OBJ +ISFLOPPY.OBJ +ISPRINTR.OBJ;
    $(LIBR) lowlib $(LOPT) +KBD_OFF.OBJ +KBD_ON.OBJ +KBDSTAT.OBJ;
    $(LIBR) lowlib $(LOPT) +MD.OBJ +NUM_ON.OBJ +PRSCREEN.OBJ +RD.OBJ;
    $(LIBR) lowlib $(LOPT) +SETBORDR.OBJ +SETDRIVE.OBJ +SETFATTR.OBJ;

# source files
CDROM.OBJ:      CDROM.C

CHGRATTR.OBJ:   CHGRATTR.C

$(CLIPB).OBJ:   $(CLIPB).C

CLKSPINR.OBJ:   CLKSPINR.C

ISWIN.OBJ:      ISWIN.C

FULLPATH.OBJ:   FULLPATH.C

NO_BOOT.OBJ:    NO_BOOT.C

PRSCROFF.OBJ:   PRSCROFF.C

PRSCRON.OBJ:    PRSCRON.C

BOOT_IT.OBJ:    BOOT_IT.ASM

CAPS_OFF.OBJ:   CAPS_OFF.ASM

CAPS_ON.OBJ:    CAPS_ON.ASM

CD.OBJ:         CD.ASM

CUR_DRV.OBJ:    CUR_DRV.ASM

FCOMMIT.OBJ:    FCOMMIT.ASM

FLOPSIZE.OBJ:   FLOPSIZE.ASM

GETBOOT.OBJ:    GETBOOT.ASM

GETDIR.OBJ:     GETDIR.ASM

GETDRIVE.OBJ:   GETDRIVE.ASM

GETFATTR.OBJ:   GETFATTR.ASM

IS_DISK.OBJ:    IS_DISK.ASM

ISDIR.OBJ:      ISDIR.ASM

ISDRIVE.OBJ:    ISDRIVE.ASM

ISEXTKBD.OBJ:   ISEXTKBD.ASM

ISFLOPPY.OBJ:   ISFLOPPY.ASM

ISPRINTR.OBJ:   ISPRINTR.ASM

ISSHARE.OBJ:    ISSHARE.ASM

KBD_OFF.OBJ:    KBD_OFF.ASM

KBD_ON.OBJ:     KBD_ON.ASM

KBDSTAT.OBJ:    KBDSTAT.ASM

MD.OBJ:         MD.ASM

NUM_OFF.OBJ:    NUM_OFF.ASM

NUM_ON.OBJ:     NUM_ON.ASM

PRSCREEN.OBJ:   PRSCREEN.ASM

RD.OBJ:         RD.ASM

SETBORDR.OBJ:   SETBORDR.ASM

SETDRIVE.OBJ:   SETDRIVE.ASM

SETFATTR.OBJ:   SETFATTR.ASM

