; function PRSCREEN.ASM to print the current screen
; (same as hitting Print Screen key)
; Sends output to LPT1
; Entry conditions: none
; Returns: Logical True if able to print, Logical False if not able
; uses procedure CHECK_PRN
; Programmer: Paul Bosselaers
; Date:       2/09/95

.model large
.286
;include \clipper5\include\extasm.inc            ; extend definitions
extrn   __retl:far

PUBLIC PRSCREEN

.code
PRSCREEN      proc    far
; save registers as required
        push    bp
        mov     bp,sp
        push    ds
        push    si
        push    di
        push    dx

; check if printer is ready
        mov     ah,02h                  ; printer status function
        xor     dx,dx                   ; LPT1 = 0
        int     17h                     ; printer status in ax
        call    CHECK_PRN               ; sets carry flag if not ready
        jc      error

; do it
        int     05h                     ; print screen function

; send a form feed
        xor     ah,ah                   ; send character function = 0
        mov     al,12                   ; form feed char.
        xor     dx,dx                   ; LPT1
        int     17h                     ; print it.

good_exit:
; set code for good exit
        mov     ax,0001
        jmp     short send_code

; set code for error
error:
        xor     ax,ax                           ; ax = 0

; return error code to clipper
send_code:
        push    ax
        call    __retl
        add     sp,2

;restore registers
        pop     dx
        pop     di
        pop     si
        pop     ds
        pop     bp
        ret
PRSCREEN      endp

; procedure CHECK_PRN to check printer status after an INT 17h call
; Entry Conditions: status in AH
; Exit Conditions: Carry set if error, Carry clear if ok
; No other procedures required.
CHECK_PRN      proc    near
        clc                     ; make sure carry flag is cleared

        cmp     ah,90h          ; is printer ready?
        je      the_end         ; the printer is ready.

not_ready:
        stc                     ; set carry for error
the_end:
        ret
CHECK_PRN      endp
        
end


