; function SETFATTR.ASM to set file attributes 
; gets file spec. from Clipper as param. 1, attribute as param. 2
; attributes as follows:
;       Normal          0
;       Read Only       1
;       Hidden          2
;       System          4
;       Archive        32
; attributes can be combined, eg. Hidden and Read-Only = 3
; the FC_ constants in Fileio.ch can be used for the 1st 4 attributes
; (Clipper doesn't define a FC_ARCHIVE constant) 
; Returns Logical True (1) if successful, logical false (0) if not.
; Programmer: Paul Bosselaers
; Date:       9/21/94

.model large
.286

include \clipper5\include\extasm.inc            ; extend definitions

PUBLIC SETFATTR

.code
SETFATTR      proc    far
; save registers as required
        push    bp
        mov     bp,sp
        push    ds
        push    si
        push    di
        push    dx
        push    cx

; check if 2 parameters were passed, exit with error if not.
        xor     ax,ax
        push    ax
        call    __parinfo
        add     sp,2
        cmp     ax,2
        jne     error

; get file spec. from clipper, dx has segment, ax has offset
        mov     ax,1
        push    ax
        call    __parc
        add     sp,2
        mov     es,dx                   ; es now has filespec segment
        mov     dx,ax                   ; dx now has filespec offset
        push    es                      ; save segment
        push    dx                      ; save offset

; get new attribute from Clipper
        mov     ax,2
        push    ax
        call    __parni
        add     sp,2

        pop     dx                      ; get back offset
        pop     es                      ; get back segment
        mov     cx,ax                   ; put attribute in cx
        push    ds                      ; save current segment
        mov     ax,es
        mov     ds,ax                   ; ds now point to filespec

; now do it
        mov     ah,43h                  ; get/set file attribute function
        mov     al,01h                  ; set em
        int     21h
        jc      error

good_exit:
; set code for good exit
        mov     ax,0001
        jmp     short send_code

; set code for error
error:
        xor     ax,ax                           ; ax = 0

; return error code to clipper
send_code:
        pop     ds
        push    ax
        call    __retl
        add     sp,2

;restore registers
        pop     cx
        pop     dx
        pop     di
        pop     si
        pop     ds
        pop     bp
        ret
SETFATTR      endp
end

        

